/****************************************************************************

  Header file for template Flat Sate Machine
  based on the Gen2 Events and Services Framework

 ****************************************************************************/

#ifndef MotorSM_H
#define MotorSM_H

// Event Definitions
#include "ES_Configure.h" /* gets us event definitions */
#include "ES_Types.h"     /* gets bool type for returns */

// typedefs for the states
// State definitions for use with the query function
typedef enum
{
    GameStart, Loading, Dunking, Unloading, Returning
}TemplateState_t;

// Public Function Prototypes

bool InitMotor(uint8_t Priority);
bool PostMotor(ES_Event_t ThisEvent);
ES_Event_t RunMotor(ES_Event_t ThisEvent);
TemplateState_t QueryMotor(void);

typedef union {
    struct{              
        uint16_t IC;
        uint16_t Rollover;
    }ByBytes;
    uint32_t Time;
} FeatureWidthTime;

typedef union {
    struct{              
        uint16_t IC2;
        uint16_t Rollover2;
    }ByBytes2;
    uint32_t Time2;
} FeatureWidthTime2;

extern volatile FeatureWidthTime TimeofLastRise, TimeofLastFall, KeepTime;
extern volatile FeatureWidthTime2 TimeofLastRise2, TimeofLastFall2, KeepTime2;

#endif /* FSMTemplate_H */

