/****************************************************************************

  Header file for Ultrasonic Service
  based on the Gen 2 Events and Services Framework

 ****************************************************************************/

#ifndef UltrasonicService_H
#define UltrasonicService_H

#include <stdint.h>
#include <stdbool.h>

#include "ES_Events.h"
#include "ES_Port.h"                // needed for definition of REENTRANT
// Public Function Prototypes

bool InitUltrasonicService(uint8_t Priority);
bool PostUltrasonicService(ES_Event_t ThisEvent);
ES_Event_t RunUltrasonicService(ES_Event_t ThisEvent);
void ResetUltrasonicServiceEvents(void);
void ResetRearFar(void);
void ResetFrontNear(void);

typedef union {
    uint32_t all;

    struct {
        uint16_t buf;
        uint16_t rollover;
    } components;
} counter;

extern volatile counter FrontCounter;
extern volatile counter RearCounter;
#endif /* ServTemplate_H */

